
:- use_module(library(lists)).


% Imperatv algoritmus trsa Prologba
% -------------------------------------

% int hatv(int a, int h) {
%   int e = 1;
%
%   while (h > 0) {
%     if (h & 1) {
%       e *= a;
%     }
%     h >>= 1;
%     a *= a;
%   }
%
%   return e;
% }

% int main() {
%   printf("hatv(2, 19) = %d\n", hatv(2, 19));
% }

% hatv(A, H, E): A-nak H-adik hatvnya E,
% ahol A, H >= 0 egszek.
hatv(A, H, E) :-                              %  int hatv(int a, int h) {
        hatv(A, H, 1, E).      		      %	   int e = 1;
					      %
% hatv(A, H, E0, E): A-nak H-adik hatvnyt   %
% E0-lal szorozva kapjuk E-t.		      %
hatv(A0, H0, E0, E) :-                        %
	H0 > 0, !,                            %	   while (h > 0) {
        (   H0 /\ 1 =:= 1   		      %	     if (h & 1) {
               % /\  bitenknti "s"	      %
        ->  E1 is E0*A0               	      %        e *= a;
        ;   E1 = E0  % E0 "nem vltozik"      %      }
        ),                     		      %
        H1 is H0 >> 1,                	      %	     h >>= 1;
        A1 is A0*A0,                   	      %	     a *= a;
        hatv(A1, H1, E1, E).   		      %    }
hatv(_, _, E, E).			      %	   return e;
