% sz(Gy, Sz): Gy szuloje Sz.
sz('Imre', 'Gizella').                   % (sz1)
sz('Imre', 'Istvan').                    % (sz2) 
sz('Istvan', 'Sarolt').                  % (sz3)
sz('Istvan', 'Geza').                    % (sz4)
sz('Gizella', 'B. Gizella').             % (sz5)
sz('Gizella', 'C. Henrik').              % (sz6)

% Gy nagyszlje NSz.
nsz(Gy, NSz) :-                          % (nsz1)
    sz(Gy, Sz),      
    sz(Sz, NSz).

% ffi(X): X ferfi.
ffi('Imre').                             % (f1)
ffi('Istvan').                           % (f2)
ffi('Geza').                             % (f3)
ffi('C. Henrik').                        % (f4)


% Gy nagyszuloje NSz.
nsz2(Gy, NSz) :- 
    nonvar(Gy),
    sz(Gy, Sz),      
    sz(Sz, NSz).
nsz2(Gy, NSz) :- 
    var(Gy),
    sz(Sz, NSz),
    sz(Gy, Sz).


end_of_file.

| ?- nsz('Imre', NA), ffi(NA).
NA = 'C. Henrik' ? ;
NA = 'Geza' ? ;
no
| ?- nsz('Imre', Nsz).
Nsz = 'Geza' ? ;
Nsz = 'Sarolt' ? ;
Nsz = 'C. Henrik' ? ;
Nsz = 'B. Gizella' ? ;
no
| ?- nsz(U, 'Geza').
U = 'Imre' ? ;
no
| ?- 
